#/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
#/******************************************************************************
#*
#* This file is provided under a dual license. When you use or
#* distribute this software, you may choose to be licensed under
#* version 2.1 of the GNU Lesser General Public License
#* ("LGPLv2.1 License") or BSD License.
#*
#* LGPLv2.1 License
#*
#* Copyright(C) 2019 MediaTek Inc.
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of version 2.1 of the GNU Lesser General Public
#* License as published by the Free Software Foundation.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#* See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
#* details.
#*
#* BSD LICENSE
#*
#* Copyright(C) 2019 MediaTek Inc.
#* All rights reserved.
#*
#* Redistribution and use in source and binary forms, with or without
#* modification, are permitted provided that the following conditions
#* are met:
#*
#* * Redistributions of source code must retain the above copyright
#* notice, this list of conditions and the following disclaimer.
#* * Redistributions in binary form must reproduce the above copyright
#* notice, this list of conditions and the following disclaimer in
#* the documentation and/or other materials provided with the
#* distribution.
#* * Neither the name of the copyright holder nor the names of its
#* contributors may be used to endorse or promote products derived
#* from this software without specific prior written permission.
#*
#* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#* HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#*
#*****************************************************************************/
#
# Set the Root Path
#
export CHILING_ROOT        ?= $(word 1, $(subst /linux_core/,/linux_core /, $(shell pwd)))
export THIRDPARTY_ROOT     ?= $(CHILING_ROOT)/../third_party
export THIRDPARTY_LIB_ROOT ?= $(THIRDPARTY_ROOT)/library/gnuarm-$(TOOL_CHAIN)
export THIRDPARTY_SRC_ROOT ?= $(THIRDPARTY_ROOT)/source

#
# OpenSrc Link Version
ZLIB_VER     ?= 1.2.3
FT_VER       ?= 2.4.3
JPEG_VER     ?= 6b
PNG_VER      ?= 1.2.43

TOOL_CHAIN   ?= 4.4.2

ROOTFS_DYNAMIC_GEN ?= ture

DFBRC_FROM_DFB ?= true
SAWMANRC_FROM_DFB ?= true

install::
	@(if test -z "$(DESTDIR)"; then echo "**** DESTDIR not set! ****"; exit 1; fi)
	install -d $(DESTDIR)$(datadir)
	install -d $(DESTDIR)$(datadir)/df_neo
	install -d $(DESTDIR)$(datadir)/shopfloor
	install -d $(DESTDIR)$(datadir)/quip
	install -d $(DESTDIR)$(sysconfdir)
	install -d $(DESTDIR)$(libdir)	
	install -c -m 644 $(MEDIATEK)/Tools/$(COMPANY)/data/*.jpg $(DESTDIR)$(datadir)/
	install -c -m 644 $(MEDIATEK)/Tools/$(COMPANY)/data/*.png $(DESTDIR)$(datadir)/
	install -c -m 644 $(MEDIATEK)/Tools/$(COMPANY)/data/*.ttf $(DESTDIR)$(datadir)/
ifeq "$(DFBRC_FROM_DFB)" "true"
	install -c -m 644 Config_mt53/directfbrc* $(DESTDIR)$(sysconfdir)
endif
ifeq "$(SAWMANRC_FROM_DFB)" "true"
	install -c -m 644 Config_mt53/sawmanrc $(DESTDIR)$(sysconfdir)
endif
	install -c -m 644 $(MEDIATEK)/Config/fusiondalerc* $(DESTDIR)$(sysconfdir)

ifeq "$(ROOTFS_DYNAMIC_GEN)" "false"
ifeq "$(FT_VER)" "2.3.7"
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/freetype/$(FT_VER)/pre-install/lib/libfreetype.so.6.3.18 $(DESTDIR)$(libdir)/
endif

ifeq "$(FT_VER)" "2.3.9"
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/freetype/$(FT_VER)/pre-install/lib/libfreetype.so.6.3.20 $(DESTDIR)$(libdir)/
endif

ifeq "$(FT_VER)" "2.4.3"
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/freetype/$(FT_VER)/pre-install/lib/libfreetype.so.6.6.1 $(DESTDIR)$(libdir)/
endif

ifeq "$(PNG_VER)" "1.2.30"
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/png/$(PNG_VER)/pre-install/lib/libpng12.so.0.30.0              $(DESTDIR)$(libdir)/
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/png/$(PNG_VER)/pre-install/lib/libpng.so.3.30.0                $(DESTDIR)$(libdir)/
endif

ifeq "$(PNG_VER)" "1.2.43"
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/png/$(PNG_VER)/pre-install/lib/libpng12.so.0.$(PNG_VER)              $(DESTDIR)$(libdir)/
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/png/$(PNG_VER)/pre-install/lib/libpng.so.3.$(PNG_VER)                $(DESTDIR)$(libdir)/
endif

	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/jpeg/$(JPEG_VER)/pre-install/lib/libjpeg.so.62.0.0             $(DESTDIR)$(libdir)/
	install -c -m 755 $(THIRDPARTY_LIB_ROOT)/zlib/$(ZLIB_VER)/pre-install/lib/libz.so.$(ZLIB_VER)       $(DESTDIR)$(libdir)/
	
ifeq "$(PNG_VER)" "1.2.30"
	ln -sf libpng12.so.0.30.0       $(DESTDIR)$(libdir)/libpng12.so.0
	ln -sf libpng12.so.0.30.0       $(DESTDIR)$(libdir)/libpng12.so
	ln -sf libpng.so.3.30.0         $(DESTDIR)$(libdir)/libpng.so.3
	ln -sf libpng.so.3.30.0         $(DESTDIR)$(libdir)/libpng.so
endif

ifeq "$(PNG_VER)" "1.2.43"
	ln -sf libpng12.so.0.$(PNG_VER)       $(DESTDIR)$(libdir)/libpng12.so.0
	ln -sf libpng12.so.0.$(PNG_VER)       $(DESTDIR)$(libdir)/libpng12.so
	ln -sf libpng.so.3.$(PNG_VER)         $(DESTDIR)$(libdir)/libpng.so.3
	ln -sf libpng.so.3.$(PNG_VER)         $(DESTDIR)$(libdir)/libpng.so
endif
	                                                    
	ln -sf libjpeg.so.62.0.0        $(DESTDIR)$(libdir)/libjpeg.so.62
	ln -sf libjpeg.so.62.0.0        $(DESTDIR)$(libdir)/libjpeg.so
	
	ln -sf libz.so.$(ZLIB_VER)  $(DESTDIR)$(libdir)/libz.so.1
	ln -sf libz.so.$(ZLIB_VER)  $(DESTDIR)$(libdir)/libz.so
	
ifeq "$(FT_VER)" "2.3.7"
	ln -sf libfreetype.so.6.3.18    $(DESTDIR)$(libdir)/libfreetype.so
	ln -sf libfreetype.so.6.3.18    $(DESTDIR)$(libdir)/libfreetype.so.6
endif

ifeq "$(FT_VER)" "2.3.9"
	ln -sf libfreetype.so.6.3.20    $(DESTDIR)$(libdir)/libfreetype.so
	ln -sf libfreetype.so.6.3.20    $(DESTDIR)$(libdir)/libfreetype.so.6
endif

ifeq "$(FT_VER)" "2.4.3"
	ln -sf libfreetype.so.6.6.1    $(DESTDIR)$(libdir)/libfreetype.so
	ln -sf libfreetype.so.6.6.1    $(DESTDIR)$(libdir)/libfreetype.so.6
endif

endif	
