/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License 
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public 
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
#ifndef __MT53_2D_H__
#define __MT53_2D_H__


//#define MT53_SUPPORTED_DRAWINGFLAGS      (DSDRAW_BLEND)
#define MT53_SUPPORTED_DRAWINGFLAGS      (DSDRAW_BLEND | DSDRAW_SRC_PREMULTIPLY | \
                                          DSDRAW_DST_PREMULTIPLY|DSDRAW_DEMULTIPLY)

#define MT53_SUPPORTED_DRAWINGFUNCTIONS  (DFXL_FILLRECTANGLE)

#define MT53_SUPPORTED_BLITTINGFLAGS     (DSBLIT_BLEND_ALPHACHANNEL | \
                                          DSBLIT_BLEND_COLORALPHA   | \
                                          DSBLIT_SRC_COLORKEY       | \
                                          DSBLIT_SRC_PREMULTCOLOR    |\
                                          DSBLIT_SRC_PREMULTIPLY    | \
                                          DSBLIT_DST_PREMULTIPLY    | \
                                          DSBLIT_DEMULTIPLY | \
                                          DSBLIT_ROTATE90    | \
                                          DSBLIT_ROTATE180    | \
                                          DSBLIT_FLIP_HORIZONTAL | \
                                          DSBLIT_ROTATE270)

#define MT53_SUPPORTED_BLITTINGFUNCTIONS (DFXL_BLIT | DFXL_STRETCHBLIT)


DFBResult mt53EngineSync   ( void                *drv,
                             void                *dev );

void mt53FlushTextureCache( void *driver_data, void *device_data, CoreSurfaceBufferLock *lock );

void mt53FlushReadCache( void *driver_data, void *device_data, CoreSurfaceBufferLock *lock );

void      mt53EngineReset  ( void                *drv,
                             void                *dev );

void      mt53EmitCommands ( void                *drv,
                             void                *dev );

void      mt53CheckState   ( void                *drv,
                             void                *dev,
                             CardState           *state,
                             DFBAccelerationMask  accel );

void mt53EngineStopDrawing( void *driver_data, void *device_data, CardState *state );

void      mt53SetState     ( void                *drv,
                             void                *dev,
                             GraphicsDeviceFuncs *funcs,
                             CardState           *state,
                             DFBAccelerationMask  accel );

#endif
