#/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
#/******************************************************************************
#*
#* This file is provided under a dual license. When you use or
#* distribute this software, you may choose to be licensed under
#* version 2.1 of the GNU Lesser General Public License
#* ("LGPLv2.1 License") or BSD License.
#*
#* LGPLv2.1 License
#*
#* Copyright(C) 2019 MediaTek Inc.
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of version 2.1 of the GNU Lesser General Public
#* License as published by the Free Software Foundation.
#*
#* This program is distributed in the hope that it will be useful, but
#* WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#* See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
#* details.
#*
#* BSD LICENSE
#*
#* Copyright(C) 2019 MediaTek Inc.
#* All rights reserved.
#*
#* Redistribution and use in source and binary forms, with or without
#* modification, are permitted provided that the following conditions
#* are met:
#*
#* * Redistributions of source code must retain the above copyright
#* notice, this list of conditions and the following disclaimer.
#* * Redistributions in binary form must reproduce the above copyright
#* notice, this list of conditions and the following disclaimer in
#* the documentation and/or other materials provided with the
#* distribution.
#* * Neither the name of the copyright holder nor the names of its
#* contributors may be used to endorse or promote products derived
#* from this software without specific prior written permission.
#*
#* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#* HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#*
#*****************************************************************************/
#
# libdirect object files
LIB_DIRECT_OBJECTS = \
	$(SOURCE)/DirectFB/lib/direct/clock.o\
	$(SOURCE)/DirectFB/lib/direct/conf.o\
	$(SOURCE)/DirectFB/lib/direct/debug.o\
	$(SOURCE)/DirectFB/lib/direct/direct.o\
	$(SOURCE)/DirectFB/lib/direct/direct_result.o\
	$(SOURCE)/DirectFB/lib/direct/fastlz.o\
	$(SOURCE)/DirectFB/lib/direct/fifo.o\
	$(SOURCE)/DirectFB/lib/direct/flz.o\
	$(SOURCE)/DirectFB/lib/direct/hash.o\
	$(SOURCE)/DirectFB/lib/direct/init.o\
	$(SOURCE)/DirectFB/lib/direct/interface.o\
	$(SOURCE)/DirectFB/lib/direct/list.o\
	$(SOURCE)/DirectFB/lib/direct/log.o\
	$(SOURCE)/DirectFB/lib/direct/log_domain.o\
	$(SOURCE)/DirectFB/lib/direct/map.o\
	$(SOURCE)/DirectFB/lib/direct/mem.o\
	$(SOURCE)/DirectFB/lib/direct/memcpy.o\
	$(SOURCE)/DirectFB/lib/direct/messages.o\
	$(SOURCE)/DirectFB/lib/direct/modules.o\
	$(SOURCE)/DirectFB/lib/direct/print.o\
	$(SOURCE)/DirectFB/lib/direct/processor.o\
	$(SOURCE)/DirectFB/lib/direct/result.o\
	$(SOURCE)/DirectFB/lib/direct/serial.o\
	$(SOURCE)/DirectFB/lib/direct/signals.o\
	$(SOURCE)/DirectFB/lib/direct/stream.o\
	$(SOURCE)/DirectFB/lib/direct/system.o\
	$(SOURCE)/DirectFB/lib/direct/trace.o\
	$(SOURCE)/DirectFB/lib/direct/tree.o\
	$(SOURCE)/DirectFB/lib/direct/thread.o\
	$(SOURCE)/DirectFB/lib/direct/utf8.o\
	$(SOURCE)/DirectFB/lib/direct/util.o\
	$(SOURCE)/DirectFB/lib/direct/uuid.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/clock.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/deprecated.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/filesystem.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/log.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/mem.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/mutex.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/signals.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/system.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/thread.o\
	$(SOURCE)/DirectFB/lib/direct/os/linux/glibc/util.o\


# libfusion object files
LIB_FUSION_OBJECTS = \
	$(SOURCE)/DirectFB/lib/fusion/arena.o\
	$(SOURCE)/DirectFB/lib/fusion/call.o\
	$(SOURCE)/DirectFB/lib/fusion/conf.o\
	$(SOURCE)/DirectFB/lib/fusion/fusion.o\
	$(SOURCE)/DirectFB/lib/fusion/hash.o\
	$(SOURCE)/DirectFB/lib/fusion/init.o\
	$(SOURCE)/DirectFB/lib/fusion/lock.o\
	$(SOURCE)/DirectFB/lib/fusion/object.o\
	$(SOURCE)/DirectFB/lib/fusion/property.o\
	$(SOURCE)/DirectFB/lib/fusion/reactor.o\
	$(SOURCE)/DirectFB/lib/fusion/ref.o\
	$(SOURCE)/DirectFB/lib/fusion/shmalloc.o\
	$(SOURCE)/DirectFB/lib/fusion/vector.o         




LIB_FUSION_OBJECTS_SINGLE = \
	$(SOURCE)/DirectFB/lib/fusion/shm/fake.o

LIB_FUSION_OBJECTS_MULTI = \
	$(SOURCE)/DirectFB/lib/fusion/shm/heap.o\
	$(SOURCE)/DirectFB/lib/fusion/shm/pool.o\
	$(SOURCE)/DirectFB/lib/fusion/shm/shm.o

LIB_VOODOO_OBJECTS = \
	$(SOURCE)/DirectFB/lib/voodoo/client.o				\
	$(SOURCE)/DirectFB/lib/voodoo/ivoodooplayer_dispatcher.o	\
	$(SOURCE)/DirectFB/lib/voodoo/server.o				\
	$(SOURCE)/DirectFB/lib/voodoo/conf.o				\
	$(SOURCE)/DirectFB/lib/voodoo/ivoodooplayer_requestor.o		\
	$(SOURCE)/DirectFB/lib/voodoo/manager.o				\
	$(SOURCE)/DirectFB/lib/voodoo/interface.o			\
	$(SOURCE)/DirectFB/lib/voodoo/play.o				\
	$(SOURCE)/DirectFB/lib/voodoo/ivoodooplayer.o			\
	$(SOURCE)/DirectFB/lib/voodoo/play_server.o
#
# DirectFB object files
DIRECTFB_OBJECTS = \
	$(SOURCE)/DirectFB/src/core/CoreDFB.o\
	$(SOURCE)/DirectFB/src/core/CoreDFB_real.o\
	$(SOURCE)/DirectFB/src/core/CoreGraphicsState.o\
	$(SOURCE)/DirectFB/src/core/CoreGraphicsState_real.o\
	$(SOURCE)/DirectFB/src/core/CoreGraphicsStateClient.o\
	$(SOURCE)/DirectFB/src/core/CoreLayer.o\
	$(SOURCE)/DirectFB/src/core/CoreLayer_real.o\
	$(SOURCE)/DirectFB/src/core/CoreLayerContext.o\
	$(SOURCE)/DirectFB/src/core/CoreLayerContext_real.o\
	$(SOURCE)/DirectFB/src/core/CoreLayerRegion.o\
	$(SOURCE)/DirectFB/src/core/CoreLayerRegion_real.o\
	$(SOURCE)/DirectFB/src/core/CorePalette.o\
	$(SOURCE)/DirectFB/src/core/CorePalette_real.o\
	$(SOURCE)/DirectFB/src/core/CoreSurface.o\
	$(SOURCE)/DirectFB/src/core/CoreSurface_real.o\
	$(SOURCE)/DirectFB/src/core/CoreWindow.o\
	$(SOURCE)/DirectFB/src/core/CoreWindow_real.o\
	$(SOURCE)/DirectFB/src/core/CoreWindowStack.o\
	$(SOURCE)/DirectFB/src/core/CoreWindowStack_real.o\
	$(SOURCE)/DirectFB/src/core/clipboard.o\
	$(SOURCE)/DirectFB/src/core/colorhash.o\
	$(SOURCE)/DirectFB/src/core/core.o\
	$(SOURCE)/DirectFB/src/core/core_parts.o\
	$(SOURCE)/DirectFB/src/core/fonts.o\
	$(SOURCE)/DirectFB/src/core/gfxcard.o\
	$(SOURCE)/DirectFB/src/core/graphics_state.o\
	$(SOURCE)/DirectFB/src/core/input.o\
	$(SOURCE)/DirectFB/src/core/layer_context.o\
	$(SOURCE)/DirectFB/src/core/layer_control.o\
	$(SOURCE)/DirectFB/src/core/layer_region.o\
	$(SOURCE)/DirectFB/src/core/layers.o\
	$(SOURCE)/DirectFB/src/core/local_surface_pool.o\
	$(SOURCE)/DirectFB/src/core/palette.o\
	$(SOURCE)/DirectFB/src/core/prealloc_surface_pool.o\
	$(SOURCE)/DirectFB/src/core/screen.o\
	$(SOURCE)/DirectFB/src/core/screens.o\
	$(SOURCE)/DirectFB/src/core/shared_surface_pool.o\
	$(SOURCE)/DirectFB/src/core/state.o\
	$(SOURCE)/DirectFB/src/core/surface.o\
	$(SOURCE)/DirectFB/src/core/surface_buffer.o\
	$(SOURCE)/DirectFB/src/core/surface_core.o\
	$(SOURCE)/DirectFB/src/core/surface_pool.o\
	$(SOURCE)/DirectFB/src/core/surface_pool_bridge.o\
	$(SOURCE)/DirectFB/src/core/system.o\
	$(SOURCE)/DirectFB/src/core/windows.o\
	$(SOURCE)/DirectFB/src/core/windowstack.o\
	$(SOURCE)/DirectFB/src/core/wm.o\
	$(SOURCE)/DirectFB/src/directfb.o\
	$(SOURCE)/DirectFB/src/directfb_result.o\
	$(SOURCE)/DirectFB/src/idirectfb.o\
	$(SOURCE)/DirectFB/src/init.o\
	$(SOURCE)/DirectFB/src/dummy.o\
	$(SOURCE)/DirectFB/src/display/idirectfbpalette.o\
	$(SOURCE)/DirectFB/src/display/idirectfbsurface.o\
	$(SOURCE)/DirectFB/src/display/idirectfbsurface_layer.o\
	$(SOURCE)/DirectFB/src/display/idirectfbsurface_window.o\
	$(SOURCE)/DirectFB/src/display/idirectfbdisplaylayer.o\
	$(SOURCE)/DirectFB/src/display/idirectfbscreen.o\
	$(SOURCE)/DirectFB/src/gfx/clip.o\
	$(SOURCE)/DirectFB/src/gfx/convert.o\
	$(SOURCE)/DirectFB/src/gfx/util.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_blit.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_draw_line.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_fill_rectangle.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_stretch_blit.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_texture_triangles.o\
	$(SOURCE)/DirectFB/src/gfx/generic/generic_util.o\
	$(SOURCE)/DirectFB/src/input/idirectfbinputdevice.o\
	$(SOURCE)/DirectFB/src/input/idirectfbinputbuffer.o\
	$(SOURCE)/DirectFB/src/media/idirectfbfont.o\
	$(SOURCE)/DirectFB/src/media/idirectfbimageprovider.o\
	$(SOURCE)/DirectFB/src/media/idirectfbvideoprovider.o\
	$(SOURCE)/DirectFB/src/media/idirectfbdatabuffer.o\
	$(SOURCE)/DirectFB/src/media/idirectfbdatabuffer_file.o\
	$(SOURCE)/DirectFB/src/media/idirectfbdatabuffer_memory.o\
	$(SOURCE)/DirectFB/src/media/idirectfbdatabuffer_streamed.o\
	$(SOURCE)/DirectFB/src/misc/conf.o\
	$(SOURCE)/DirectFB/src/misc/util.o\
	$(SOURCE)/DirectFB/src/misc/gfx_util.o\
	$(SOURCE)/DirectFB/inputdrivers/joystick/joystick.o\
	$(SOURCE)/DirectFB/src/windows/idirectfbwindow.o


# DirectFB header files
DIRECTFB_INCLUDES += \
	-I$(SOURCE)/DirectFB\
	-I$(SOURCE)/DirectFB/include\
	-I$(SOURCE)/DirectFB/lib\
	-I$(SOURCE)/DirectFB/lib/direct\
	-I$(SOURCE)/DirectFB/src\
	-I$(SOURCE)/DirectFB/proxy/dispatcher\
	-I$(SOURCE)/DirectFB/proxy/requestor\
	-I$(SOURCE)/DirectFB/systems

ifdef OBJ_ROOT
DIRECTFB_INCLUDES += -I$(OBJ_ROOT)/Source/DirectFB/include
endif
