#ifndef __MT53_GFXDRIVER_H__
#define __MT53_GFXDRIVER_H__

#include <gfx_cmdque.h>


typedef struct {
     /* validation flags */
     int                    v_flags;

     /* cached/computed values */
     void                  *dst_addr;
     unsigned long          dst_phys;
     unsigned long          dst_pitch;
     DFBSurfacePixelFormat  dst_format;
     unsigned long          dst_bpp;

     void                  *src_addr;
     unsigned long          src_phys;
     unsigned long          src_pitch;
     DFBSurfacePixelFormat  src_format;
     unsigned long          src_bpp;

     DFBColor               color;
     unsigned long          color_pixel;

     u32                    bltopts;
} MT53DeviceData;


typedef struct {
     /* file descriptor from /dev/fb0 */
     int                    fd;

     /* mapping of shared command queue control structure and DMA region */
     volatile GFX_CMDQUE_T *shm_cmd_que;
     volatile UINT64       *cmd_que_buf;
} MT53DriverData;


#endif
